/*
    TARJETAS DE RESEÑAS

    Mirar las paginas principales para ver
    la explicación de ciertos atributos comunes:
    - index.html
    - reviews.html
    - contact.html


*/
.ReviewDetailed,
.ReviewDetailed * {
    box-sizing: border-box;
    margin: 0;
    padding: 0;
}

/*
    Se usan en las reseñas para expandir
    la opinion del usuario o mostrar un resumen
    por tanto no hace falta visualizarlas ni
    que ocupen espacio, pero si su funcionalidad
*/
input[type="checkbox"] {
    display: none;
}

/*
    Animación que genera un pulso en el tamaño
*/
@keyframes AnimPulse {
    0% {
        transform: scale(1);
    }

    50% {
        transform: scale(1.05);
    }

    100% {
        transform: scale(1);
    }
}

/*
    La tarjeta en sí utiliza flez en columna
    para distribuir los elementos

  */
.ReviewDetailed {
    position: relative;
    cursor: pointer;
    font-size: 1.1em;
    border: 10px;
    background-color: rgb(24, 24, 24);
    color: white;
    display: flex;
    flex-direction: column;
    justify-content: center;
    border-radius: 5px;
    box-shadow: 5px 5px 15px 5px black;
}

/*
    usamos la animación porque no queremos
    que esté todo el rato en grande aunque
    tengamos el ratón encima todo el rato
*/
.ReviewDetailed:hover {
    animation: AnimPulse .7s ease;
}

/*
    Creamos la parte superior
    donde estan:
    - titulo
    - valoracion
    - autor
    - fecha
    - imagen
*/
.ReviewDetailed .Top {
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: start;
    border-radius: 10px;
}

/*
    hacemos que esta parte ocupe todo
    el espacio y que donde esta la foto
    coja el espacio que ocupe su ancho
    y se ajuste al contenido
*/
.ReviewDetailed .Top .Left {
    display: flex;
    flex-direction: column;
    flex-grow: 1;
    padding: 10px;
    justify-content: center;
    align-items: center;
}

.ReviewDetailed .Top .Left * {
    padding: 5px;
}

/*
    El titulo debe ser un poco
    más grande que el contenido
*/
.ReviewDetailed .Top .Left .Title {
    font-size: 1.2em;
}

.ReviewDetailed .Top .Left .Rating {
    display: flex;
    gap: 10px;
    align-items: center;
}

/*
    Esta es la barra de valoracion
    la cual cacula un porcentaje y
    lo guarda en la variable percent
    que se usará despues para visualizar
    cuantas estrellas doradas, que es
    en verdad un gradiente se necesita
    para rellenar de color las estrellas

*/
.ReviewDetailed .Top .Left .RatingBar {
    appearance: none;
    font-family: sans-serif;
    font-size: 1.2em;
    --percent: calc(var(--value) / 10 * 100%)
}

/*
    Es aqui donde usamos el gradiente para el
    contenido se puede usar el codigo unicode
    o copiar y pegar el símbolo directamente
    en el cotenido del elemento que debe ser
    un texto, que es transparente para que
    se visualice nuestro background en vez
    del color del texto y para que solo pinte
    el area de texto y no todo el fondo usamos
    background-clip, por tanto esto funciona
    como una mascara y como una capa
*/


.ReviewDetailed .Top .Left .RatingBar::before {
    background-image: linear-gradient(90deg, #fc0 var(--percent), #eee var(--percent));
    background-clip: text;
    content: '★★★★★★★★★★';
    /* content: "\2605\2605\2605\2605\2605\2605\2605\2605\2605\2605"; */
    color: transparent;
}

.ReviewDetailed .Top .Left .Subtitle {
    width: 90%;
    display: flex;
    justify-content: space-between;
}

/*
    como antes hemos hecho que la parte
    izquierda se adapte al contenido de la
    derecha especificamos un tamaño de imagen
    fijo y cuadrado ya que el tamaño de tarjeta
    no varía.
    El z-index se necesita para estar por encima
    de elementos que van despues en el html por
    si queremos invadir su zona
*/

.ReviewDetailed .Top .Right {
    width: 100px;
    height: 100px;
    padding: 15px 15px 0 0;
    z-index: 1;
}

.ReviewDetailed .Top .Right .Avatar {
    width: 100%;
    height: 100%;
    border-radius: 50%;
    background-repeat: no-repeat;
    background-position: center;
    background-size: contain;
    transition: all .5s;
}

/*
    Tiene una pequeña transicion desde
    la esquina superior derecha
    con ese tamaño el z-index no haría
    falta
*/

.ReviewDetailed .Top .Right .Avatar:hover {
    transform: scale(1.5);
    transform-origin: top right;
}

/*
    En la parte de abajo va un
    un resumen y el texo del usuario
    Se usa relative por el posicionamiento
    absoluto de las capas hijas
*/
.ReviewDetailed .Bottom {
    flex-grow: 1;
    position: relative;
    display: flex;
    flex-direction: column;
}


.ReviewDetailed .Bottom .Summary {
    margin: 5px;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    background-color: rgb(37, 36, 36);
    transform-origin: top;
}

.ReviewDetailed .Bottom .Summary .Title {
    padding: 20px;
    color: rgb(175, 173, 173);
}

/*
    este es el elemento mostrar más
*/
.ReviewDetailed .Bottom .Summary .Subtitle {
    color: rgb(107, 170, 221);
    padding: 10px;
}

.ReviewDetailed .Bottom .Content {
    display: none;
    top: 0;
    margin: 5px;
    padding: 20px;
    background-color: rgb(62, 62, 62);
    color: rgb(175, 173, 173);
    transform-origin: top;
}

.ReviewDetailed input[type="checkbox"]:checked~.Bottom .Summary {
    display: none;
}

/*
    va a haber una pequeña transicion
    de opacidad para los contenidos ocultos
*/

.ReviewDetailed input[type="checkbox"]:checked~.Bottom .Content {
    display: block;
    opacity: 1;
    transition: opacity .5s, display .5s;
}

/*
    Para que funcione la transicion es necesario
    esta nueva regla ya que al poner display none
    la transicion de opacidad no funcionaria pues
    no sabe que valor tenía ese elemento ya que
    no forma parte del renderizado si se pone a none
*/
@starting-style {
    .ReviewDetailed input[type="checkbox"]:checked~.Bottom .Content {
        opacity: 0.75;
    }

    .ReviewDetailed .Bottom .Summary {
        opacity: 0.75;
    }

}